

#include <iostream>
using namespace std;

//point class
class point {
public:
	void scale(int);
	void add(point &);
	void print();
	point(int,int);
	point();
	int x;
	int y;
};
//

class line {
public:
	line(float,float);
	line();
	void print();
	bool isIdentical(line &);
	bool isParallel(line &);
	point intersect(line &);
private:
	float a;
	float b;
	bool parallelToyaxis;
};



line::line(float aa,float bb) {
	a=aa;
	b=bb;
	if (a>999) {
		a=999;
		parallelToyaxis=true;
	}
	else parallelToyaxis=false;
	//on error cout<<"Error, invalid parameters entered!"; exit(0);
}

line::line() {
	a=1;
	b=0;
	parallelToyaxis=false;
}

void line::print() {
	cout<<"y=ax+b\na= "<<a<<"\nb= "<<b<<endl<<endl;
}

bool line::isIdentical(line &line2) {
	if (a==line2.a && b==line2.b) return true;
	else return false;
}

bool line::isParallel(line &line2) {
	if (a==line2.a && b!=line2.b) return true;
	else return false;
}


// point 
void point::print() {
	cout<<"("<<x<<","<<y<<")\n";
}

point :: point(int xx,int yy) {
	x=xx;
	y=yy;
}

point :: point() {
	x=0;
	y=0;
}

void point :: add(point &q) {
	x=x+q.x;
	y=y+q.y;
}

void point :: scale(int a) {
	x=a*x;
	y=a*y;
}
//

point line::intersect(line &line2){
	if (isIdentical(line2) || isParallel(line2) ) {
		cout<<"Error, lines are parallel or identical!\n";
		exit(0);
	}
	else {
		float x=(line2.b-b)/(a-line2.a);
		float y=a*x+b;
		point p(x,y);
		return p;
	}

}

void intersectAll(line L[], int n, point P[], int & m); 

void intersectAll(line L[], int n, point P[], int & m) {
	m=0;
	int k=0;
	for (int i=0;i<n;i++) {
		for (int j=i;j<n;j++) {
			if (!L[i].isIdentical(L[j]) && !L[i].isParallel(L[j]) ) {
				P[k]=L[i].intersect(L[j]);
				k++;
				m++;
			}
		}
	}
	
}

void main() {
	line l1(2,0);
	line l2(4,1);
	l1.print();
	point p=l1.intersect(l2);
	p.print();
	cout<<"\nTest for intersectAll: \n";
	line l3(5,8);
	line l4(2,6);
	line l5(5,7);
	line l6(6,3);
	line L[]={l3,l4,l5,l6};
	point P[100];
	int m;
	intersectAll(L,4,P,m);
	cout<<endl<<"m="<<m<<endl;
	for(int i=0;i<m;i++) {
		P[i].print();
	}
}

